<template>
  <el-table-column v-if="type" :type="type" :selectable="selectable" :min-width="minWidth" :label="label" :fixed="fixed"
                   :align="align" :reserve-selection="type==='selection'&&openReserve"/>
  <el-table-column v-else :label="label" :prop="prop"
                   :min-width="minWidth" :show-overflow-tooltip="showOverflow"
                   :align="align" :fixed="fixed" :sortable="sortable">
    <slot name="otherColumn"></slot>
    <template #header="{row,$index}">
      <slot name="header">
        <span style="color: red" v-if="required">*</span>
        <span>{{ label }}</span>
      </slot>
    </template>
    <template #default="{ row, $index }">
      <slot :row="row" :index="$index">{{ row[prop] }}</slot>
    </template>
  </el-table-column>
</template>

<script>
export default {
  name: 'CustomColumn',
  props: {
    openReserve: {
      type: Boolean,
      default: false,
    },
    type: {
      type: String,
      default: '',
    },
    selectable: {
      type: Function,
    },
    label: {
      type: String,
      default: '',
    },
    prop: {
      type: String,
    },
    minWidth: {
      type: Number,
      default: 0,
    },
    fixed: {
      type: String,
    },
    sortable: {
      type: Boolean,
      default: false,
    },
    align: {
      type: String,
      default: 'center',
    },
    showOverflow: {
      type: Boolean,
      default: true,
    },
    required: {
      type: Boolean,
      default: false
    }
  },
  methods: {
    // 自适应表格列宽
    flexColumnWidth(str, arr1, flag = 'max') {
      // str为该列的字段名(传字符串);tableData为该表格的数据源(传变量);
      // flag为可选值，可不传该参数,传参时可选'max'或'equal',默认为'max'
      // flag为'max'则设置列宽适配该列中最长的内容,flag为'equal'则设置列宽适配该列中第一行内容的长度。
      str = str + ''
      let columnContent = ''
      if (!arr1 || !arr1.length || arr1.length === 0) {
        return '80px' // 给个默认的
      }
      if (!str || !str.length || str.length === 0) {
        return '80px' // 给个默认的
      }
      if (flag === 'equal') {
        // 获取该列中第一个不为空的数据(内容)
        for (let i = 0; i < arr1.length; i++) {
          if (arr1[i]['obj1']['string'].length > 0) {
            columnContent = arr1[i]['obj1']['string']
            break
          }
        }
      } else {
        // 获取该列中最长的数据(内容)
        let index = 0
        for (let i = 0; i < arr1.length; i++) {
          if (arr1[i]['obj1']['string'] === null) {
            return
          }
          const now_temp = arr1[i]['obj1']['string'] + ''
          const max_temp = arr1[index]['obj1']['string'] + ''
          if (now_temp.length > max_temp.length) {
            index = i
          }
        }
        columnContent = arr1[index]['obj1']['string']
      }
      // 以下分配的单位长度可根据实际需求进行调整
      let flexWidth = 0
      for (const char of columnContent) {
        if ((char >= 'A' && char <= 'Z') || (char >= 'a' && char <= 'z')) {
          // 如果是英文字符，为字符分配8个单位宽度
          flexWidth += 8
        } else if (char >= '\u4e00' && char <= '\u9fa5') {
          // 如果是中文字符，为字符分配15个单位宽度
          flexWidth += 15
        } else {
          // 其他种类字符，为字符分配8个单位宽度
          flexWidth += 8
        }
      }
      if (flexWidth < 80) {
        // 设置最小宽度
        flexWidth = 80
      }
      // if (flexWidth > 250) {
      //   // 设置最大宽度
      //   flexWidth = 250
      // }

      // 可以再多留部分的padding
      flexWidth += 30
      return flexWidth + 'px'
    }
  }

}
</script>
